/**********************************************************************
 *	LED Dynamic Drive
 **********************************************************************
 *
 *	LED̕\ݒ : S܂ł̐Zbg.
 *  void led_set_number(int data);
 *
 *
 *	_Ci~bN_[`(TASK).
 *	void led_task(void);
 *
 **********************************************************************
 *	ڑ:
            PC5   ===> LED_h
            PC4   ===> LED_g
            PC3   ===> LED_f
            PC2   ===> LED_e
            PC1   ===> LED_d
            PB2   ===> LED_c
            PB1   ===> LED_b
            PB0   ===> LED_a

            PB5   ===> LED_COMMON_4
            PB4   ===> LED_COMMON_3
            PB3   ===> LED_COMMON_2
            PD5   ===> LED_COMMON_1
 **********************************************************************
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "config.h"
#include "task.h"
#include "taskdef.h"
#include "timer.h"

static	uchar seg_tbl[12]=
{
	0b00111111,	// 0
	0b00000110,	// 1
	0b01011011,	// 2
	0b01001111,	// 3
	0b01100110,	// 4
	0b01101101,	// 5
	0b01111101,	// 6
	0b00000111,	// 7
	0b01111111,	// 8
	0b01101111,	// 9
	0b01000000,	// -
	0b00000000,	// off
};

static	uchar led_data[4];

#define	MINUSLED	10
#define	OFFLED		11

/**********************************************************************
 *	led
 **********************************************************************
 */
static void set_led(uchar d)
{
	d ^= 0xff;
	PORTB = (PORTB & ~0b0000_0111 ) | (d & 0b0000_0111);
	PORTC = (d & 0b1111_1000)>>2;
}
/**********************************************************************
 *	LED COMMON Drive
 **********************************************************************
            PB5   ===> LED_COMMON_4 (MSB)
            PB4   ===> LED_COMMON_3
            PB3   ===> LED_COMMON_2
            PD5   ===> LED_COMMON_1 (LSB)
 */
static void set_common(uchar d)
{
	if(d & 1) PORTD |=  (1<<5);
	else	  PORTD &= ~(1<<5);

	PORTB = ( PORTB & ~0b0011_1000 ) | ((d & 0x0e) << 2);
//	PORTB = 0b0011_1000;
}
/**********************************************************************
 *	
 **********************************************************************
 */
void set_digit(uchar id,uchar num)
{
	led_data[id & 3] = seg_tbl[num];
}
/**********************************************************************
 *	l(n)  (m)Ŋ. ] *r ɕԂ.
 **********************************************************************
 */
static uchar divnum(int n,int m,int *r)
{
	uchar d=0;
	while(  n >= m) {
		n = n - m;
		d++;
	}
	*r = n;
	return d;
}

/**********************************************************************
 *	LED̕\ݒ :  ʒudigitڂɍ킹.
 **********************************************************************
 */
void led_set_comma(uchar digit)
{
	led_data[digit & 3] |= 0x80;	// LED h onɂ.
}
/**********************************************************************
 *	LED̕\ݒ : ʌ̃[.
 **********************************************************************
 */
void led_set_zero_supress(void)
{
	uchar i;
	for(i=3;i>0;i--) {
		if(	led_data[i]==seg_tbl[0]) {
			led_data[i]= 0;	//ʌ̃[.
		}else{
			break;
		}
	}
}

/**********************************************************************
 *	LED̕\ݒ : S܂ł̐Zbg.
 **********************************************************************
 */
void led_set_number(int data)
{
	uchar num[4];
	uchar i;
	num[3] = divnum(data,1000,&data);
	num[2] = divnum(data, 100,&data);
	num[1] = divnum(data,  10,&data);
	num[0] = data;

	for(i=0;i<4;i++) {
		set_digit(i,num[i]);
	}
}
/**********************************************************************
 *	LED̕\ݒ : S̃p^[Zbg.
 **********************************************************************
 */
void led_set_pattern(uchar *data)
{
	uchar i;
	for(i=0;i<4;i++) {
		led_data[i]=data[i];
	}
}
/**********************************************************************
 *	task
 **********************************************************************
 */
void led_task(void)
{
	static uchar cnt=0;

	set_common(0);
	set_led(led_data[cnt]);
	set_common(1<<cnt);

	cnt--;
	if(cnt==0xff) {
		cnt = 3;
#if	1
		// ŏʌ[TvXꂽꍇ
		//_Ci~bN_Duty33ɂď邭.
		if(led_data[cnt]==0) cnt--;
#endif

	}
	sleep_tsk(2);		//2tick ҂.
}


/**********************************************************************
 *	
 **********************************************************************
 */
